import json
import os

#Чтение конфигурации
def read_config():
    return read_json("./config.json") #Нужно сделать проверку данных
#Запись конфигурации
async def write_config(config:str):
    return await write_json("./config.json", config) #Нужно сделать проверку данных
#Чтение модели камеры
def read_camera(model):
    return read_json("./models/" + model + ".json") #Нужно сделать проверку данных

#Загрузка суммарной конфигурации
def load_config():
    cfg = read_config()
    result = read_camera(cfg["model"])
    result["user"] = cfg["user"]
    result["password"] = cfg["password"]
    result["ip"] = cfg["ip"]
    result["port"] = cfg["port"]
    result["crop"] = cfg["crop"]
    result["atype"] = cfg["atype"]
    result["nsnap"] = cfg["nsnap"]
    return result

def load_config_env(ip = "127.0.0.1", port = "80", user = "admin", password = "admin", model = "DH-SD49225XA-HNR-S3.json", crop = "1", atype = "digest", nsnap = "1024"):
    result = read_camera(model)
    result["user"] = user
    result["password"] = password
    result["ip"] = ip
    result["port"] = port
    result["crop"] = int(crop)
    result["atype"] = atype
    result["nsnap"] = int(nsnap)
    return result

def clear_old_refs():
    #Все имеена файлов в каталоге
    filenames = next(os.walk("./refs/"), (None, None, []))[2]
    preset_refs = []
    #Все существующие пресеты
    presets = next(os.walk("./presets/"), (None, None, []))[2]
    for pfn in presets:
        path = f"./presets/{pfn}"
        pfile = open(path)
        json_data = json.load(pfile)
        pfile.close()
        for json_preset in json_data["References"]:
            preset_refs.append(json_preset["Image"])
    preset_refs = list(set(preset_refs))
    #Удаляю из списка существубщие пресеты
    for name in preset_refs:
        try: filenames.remove(name)
        except: pass
    #Удаляю из списка jpg
    for name in filenames:
        if name.find(".jpg") >=0:
            try: filenames.remove(name)
            except: pass
    #Удаляю файлы
    for name in filenames:
        os.remove(f"./refs/{name}")

# async def w_new_preset(id,snap, x, y, z, description):
#     new_preset = {



#     }

    
#     result = {"pan":x, "tilt":y, "zoom":z, "snap_id": snap, "description": description}
#     await write_json("./presets/" + str(id) + ".json", result)


async def write_preset(id,snap, x, y, z, description):

    result = {"pan":x, "tilt":y, "zoom":z, "snap_id": snap, "description": description}
    await write_json("./presets/" + str(id) + ".json", result)

def read_preset(id):
    result = read_json("./presets/" + str(id) + ".json")
    return result

#Поиск наименьшего id пресета
def find_min_id():
    filenames = next(os.walk("./presets/"), (None, None, []))[2]  # [] if no file
    id = 1
    for name in sorted(filenames):
        fileid = str.strip(name,".json")
        if str.isnumeric(fileid):
            if int(fileid) == id:
                id = id+1;
    return id

def id_exist(id):
    filenames = next(os.walk("./presets/"), (None, None, []))[2]  # [] if no file
    result  = False
    for name in sorted(filenames):
        fileid = str.strip(name,".json")
        if str.isnumeric(fileid):
            if int(fileid) == int(id):
                result = True
    return result

def preset_list():
    result = []
    filenames = next(os.walk("./presets/"), (None, None, []))[2]  # [] if no file
    for name in sorted(filenames):
        id = int(str.strip(name,".json"))
        payload = read_preset(id)
        payload["id"] = str(id)
        result.append(payload)
    return result

def snap_remover(num):
    num = num - 1
    filenames = next(os.walk("./snaps/"), (None, None, []))[2]
    snap_id = sorted(filenames)
    if len (snap_id) > int(num):
        rem_len = len(snap_id) - num
        snap_id = snap_id[:rem_len]
        for name in snap_id:
            os.remove("./snaps/" + name)
    pass

    


#Чтение из файла
def read_json(path):
    pfile = open(path)
    #Добавить ошибку если файл не существует
    preset = json.load(pfile)
    pfile.close()
    return preset

#Запись пресета в файл
async def write_json(path, preset_dict):
    # print("test")
    pfile = open(path,'w')
    preset=json.dumps(json.load(preset_dict),indent=4)
    pfile.write(preset)
    pfile.close
    #Добавить ошибку если файл не существует
