""" В файле прописаны алгоритмы подготовки данных """
import json



#Генерирует JSON для нового пресета
#Координаты в градусах, мм
def pj_create_preset(id, snap, x, y, z):
    #При создании пресета заполняется только поле base из исходных данных. Остальное нули
    str_empty = {"snap":"", "x":0.0, "y":0.0}
    str_base = {"snap": snap, "x":0.0, "y":0.0}
    str_images = {"base": str_base, "day": str_empty, "night": str_empty, "adaptive": str_empty}
    str_ptz = {"pan":x, "tilt":y, "zoom":z}
    str_full = {"id":id, "ptz":str_ptz, "images":str_images}
    # print(str_empty)
    return json.dumps(str_full)

#Добавляет или обновляет картинки, с заделом на оценку сдвига пресетов односительно друг друга
def pj_add_snap(id, pr_name:str, pr_data:str, snap, sh_x:float = 0.0, sh_y:float = 0.0):
    #Проверка, допустимые ли имена подпресетов
    if (pr_name == "base")  or (pr_name == "adaptive") or (pr_name == "day") or (pr_name == "night"):
        result = json.loads(pr_data)
        subdata = result["images"][pr_name]
        subdata["snap"] = snap
        subdata["x"] = sh_x
        subdata["y"] = sh_y
        result["images"][pr_name] = subdata
        return json.dumps(result)
    else:
        return None
    
def pj_add_snap(id, pr_name:str, pr_data:str, snap, sh_x:float = 0.0, sh_y:float = 0.0):
    #Проверка, допустимые ли имена подпресетов
    if (pr_name == "base")  or (pr_name == "adaptive") or (pr_name == "day") or (pr_name == "night"):
        result = json.loads(pr_data)
        subdata = result["images"][pr_name]
        subdata["snap"] = snap
        subdata["x"] = sh_x
        subdata["y"] = sh_y
        result["images"][pr_name] = subdata
        return json.dumps(result)
    else:
        return None
    
#Удаляет существующие референсы(кроме базового)
def pj_rm_snap(id, pr_name:str, pr_data:str):
    #Проверка, допустимые ли имена подпресетов
    if (pr_name == "base"):
        return None
    elif (pr_name == "adaptive") or (pr_name == "day") or (pr_name == "night"):
        result = json.loads(pr_data)
        subdata = result["images"][pr_name]
        subdata["snap"] = ""
        subdata["x"] = 0.0
        subdata["y"] = 0.0
        result["images"][pr_name] = subdata
        return json.dumps(result)
    else:
        return None